searchNodes=[{"doc":"LiveDashboard provides real-time performance monitoring and debugging tools for Phoenix developers. It provides the following modules: Home - See general information about the system OS Data - See general information about OS, such as CPU, Memory and Disk usage Metrics - See how your application performs under different conditions by visualizing :telemetry events with real-time charts Request logging - See everything that was logged for certain requests Applications - See, filter, and search applications in the current node Processes - See, filter, and search processes in the current node Ports - See, filter, and search ports (responsible for I/O) in the current node Sockets - See, filter, and search sockets (responsible for tcp/udp) in the current node ETS - See, filter, and search ETS tables (in-memory storage) in the current node Ecto Stats - Shows index, table, and general usage about the underlying Ecto Repo storage The dashboard also works across nodes. If your nodes are connected via Distributed Erlang, then you can access information from node B while accessing the dashboard on node A. Installation To start using LiveDashboard, you will need three steps: Add the phoenix_live_dashboard dependency Configure LiveView Add dashboard access 1. Add the phoenix_live_dashboard dependency Add the following to your mix.exs and run mix deps.get : def deps do [ { :phoenix_live_dashboard , &quot;~&gt; 0.5&quot; } ] end 2. Configure LiveView The LiveDashboard is built on top of LiveView. If LiveView is already installed in your app, feel free to skip this section. If you plan to use LiveView in your application in the future, we recommend you to follow the official installation instructions . This guide only covers the minimum steps necessary for the LiveDashboard itself to run. First, update your endpoint's configuration to include a signing salt. You can generate a signing salt by running mix phx.gen.secret 32 (note Phoenix v1.5+ apps already have this configuration): # config/config.exs config :my_app , MyAppWeb.Endpoint , live_view : [ signing_salt : &quot;SECRET_SALT&quot; ] Then add the Phoenix.LiveView.Socket declaration to your endpoint: socket &quot;/live&quot; , Phoenix.LiveView.Socket And you are good to go! 3. Add dashboard access for development-only usage Once installed, update your router's configuration to forward requests to a LiveDashboard with a unique name of your choosing: # lib/my_app_web/router.ex use MyAppWeb , :router import Phoenix.LiveDashboard.Router ... if Mix . env ( ) == :dev do scope &quot;/&quot; do pipe_through :browser live_dashboard &quot;/dashboard&quot; end end This is all. Run mix phx.server and access the &quot;/dashboard&quot; to configure the necessary modules. Extra: Add dashboard access on all environments (including production) If you want to use the LiveDashboard in production, you should put it behind some authentication and allow only admins to access it. If your application does not have an admins-only section yet, you can use Plug.BasicAuth to set up some basic authentication as long as you are also using SSL (which you should anyway): # lib/my_app_web/router.ex use MyAppWeb , :router import Phoenix.LiveDashboard.Router ... pipeline :admins_only do plug :admin_basic_auth end scope &quot;/&quot; do pipe_through [ :browser , :admins_only ] live_dashboard &quot;/dashboard&quot; end defp admin_basic_auth ( conn , _opts ) do username = System . fetch_env! ( &quot;AUTH_USERNAME&quot; ) password = System . fetch_env! ( &quot;AUTH_PASSWORD&quot; ) Plug.BasicAuth . basic_auth ( conn , username : username , password : password ) end If you are running your application behind a proxy or a webserver, you also have to make sure they are configured for allowing WebSocket upgrades. For example, here is an article on how to configure Nginx with Phoenix and WebSockets. Finally, you will also want to configure your config/prod.exs and use your domain name under the check_origin configuration: check_origin : [ &quot;//myapp.com&quot; ] Then you should be good to go! Using from the command line with PLDS It's possible to use the LiveDashboard without having to add it as a dependency of your application, or when you don't have Phoenix installed. PLDS is a command line tool that provides a standalone version of LiveDashboard with some batteries included. You can install it with: $ mix escript.install hex plds And connect to a running node with: $ plds server --connect mynode --open For more details, please check the PLDS documentation .","ref":"Phoenix.LiveDashboard.html","title":"Phoenix.LiveDashboard","type":"module"},{"doc":"Extracts a datapoint for the given metric. Receives a Telemetry.Metric as metric , alongside the measurements and metadata from the Telemetry event, and an optional time and returns an extracted datapoint or nil if the event is not part of the metric. Note that it is expected that the event name was already validated as part of the metric.","ref":"Phoenix.LiveDashboard.html#extract_datapoint_for_metric/4","title":"Phoenix.LiveDashboard.extract_datapoint_for_metric/4","type":"function"},{"doc":"Page builder is the default mechanism for building custom dashboard pages. Each dashboard page is a LiveView with additional callbacks for customizing the menu appearance. One notable difference, however, is that a page implements a render_page/1 callback, which must return one or more page builder components, instead of a render/1 callback that returns ~H or ~L (deprecated). A simple and straight-forward example of a custom page is the Phoenix.LiveDashboard.ETSPage that ships with the dashboard: defmodule Phoenix.LiveDashboard.EtsPage do @moduledoc false use Phoenix.LiveDashboard.PageBuilder @impl true def menu_link ( _ , _ ) do { :ok , &quot;ETS&quot; } end @impl true def render_page ( _assigns ) do table ( columns : table_columns ( ) , id : :ets_table , row_attrs : &amp; row_attrs / 1 , row_fetcher : &amp; fetch_ets / 2 , rows_name : &quot;tables&quot; , title : &quot;ETS&quot; ) end defp fetch_ets ( params , node ) do %{ search : search , sort_by : sort_by , sort_dir : sort_dir , limit : limit } = params # Here goes the code that goes through all ETS tables, searches # (if not nil), sorts, and limits them. # # It must return a tuple where the first element is list with # the current entries (up to limit) and an integer with the # total amount of entries. # ... end defp table_columns ( ) do [ %{ field : :name , header : &quot;Name or module&quot; , } , %{ field : :protection } , %{ field : :type } , %{ field : :size , cell_attrs : [ class : &quot;text-right&quot; ] , sortable : :desc } , %{ field : :memory , format : &amp; format_words / 1 , sortable : :desc } , %{ field : :owner , format : &amp; encode_pid / 1 } ] end defp row_attrs ( table ) do [ { &quot;phx-click&quot; , &quot;show_info&quot; } , { &quot;phx-value-info&quot; , encode_ets ( table [ :id ] ) } , { &quot;phx-page-loading&quot; , true } ] end end Once a page is defined, it must be declared in your live_dashboard route as follows: live_dashboard &quot;/dashboard&quot; , additional_pages : [ route_name : MyAppWeb.MyCustomPage ] Or alternatively: live_dashboard &quot;/dashboard&quot; , additional_pages : [ route_name : { MyAppWeb.MyCustomPage , some_option : ... } ] The second argument of the tuple will be given to the init/1 callback. If not tuple is given, init/1 will receive an empty list. Components A page can only have the components listed with this page. We currently support card/1 , columns/1 , fields_card/1 , layered_graph/1 , nav_bar/1 , row/1 , shared_usage_card/1 , table/1 , and usage_card/1 . Helpers Some helpers are available for page building. The supported helpers are: live_dashboard_path/2 , live_dashboard_path/3 , encode_app/1 , encode_ets/1 , encode_pid/1 , encode_port/1 , and encode_socket/1 .","ref":"Phoenix.LiveDashboard.PageBuilder.html","title":"Phoenix.LiveDashboard.PageBuilder","type":"behaviour"},{"doc":"Renders a card component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do card ( title : &quot;Run queues&quot; , inner_title : &quot;Total&quot; , class : [ &quot;additional-class&quot; ] , value : 1.5 ) end You can see it in use the Home and OS Data pages. Options These are the options supported by the component: :value - Required. The value that the card will show. :title - The title above the card. Default: nil . :inner_title - The title inside the card. Default: nil . :hint - A textual hint to show close to the title. Default: nil . :inner_hint - A textual hint to show close to the inner title. Default: nil . :class - A list of additional css classes that will be added along banner-card class. Default: [] .","ref":"Phoenix.LiveDashboard.PageBuilder.html#card/1","title":"Phoenix.LiveDashboard.PageBuilder.card/1","type":"function"},{"doc":"Renders a column component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do columns ( columns : [ card ( ... ) , card_usage ( ... ) ] ) end You can see it in use the Home page and OS Data pages. Options These are the options supported by the component: :columns - Required. A list of components. It can receive up to 3 components. Each element will be one column.","ref":"Phoenix.LiveDashboard.PageBuilder.html#columns/1","title":"Phoenix.LiveDashboard.PageBuilder.columns/1","type":"function"},{"doc":"Encodes an application for URLs. Example This function can be used to encode an application for an event value: &lt; button phx - click = &quot;show-info&quot; phx - value - info = &lt; % = encode_app ( @my_app ) % &gt; / &gt;","ref":"Phoenix.LiveDashboard.PageBuilder.html#encode_app/1","title":"Phoenix.LiveDashboard.PageBuilder.encode_app/1","type":"function"},{"doc":"Encodes ETSs references for URLs. Example This function can be used to encode an ETS reference for an event value: &lt; button phx - click = &quot;show-info&quot; phx - value - info = &lt; % = encode_ets ( @reference ) % &gt; / &gt;","ref":"Phoenix.LiveDashboard.PageBuilder.html#encode_ets/1","title":"Phoenix.LiveDashboard.PageBuilder.encode_ets/1","type":"function"},{"doc":"Encodes PIDs for URLs. Example This function can be used to encode a PID for an event value: &lt; button phx - click = &quot;show-info&quot; phx - value - info = &lt; % = encode_pid ( @pid ) % &gt; / &gt;","ref":"Phoenix.LiveDashboard.PageBuilder.html#encode_pid/1","title":"Phoenix.LiveDashboard.PageBuilder.encode_pid/1","type":"function"},{"doc":"Encodes Port for URLs. Example This function can be used to encode a Port for an event value: &lt; button phx - click = &quot;show-info&quot; phx - value - info = &lt; % = encode_port ( @port ) % &gt; / &gt;","ref":"Phoenix.LiveDashboard.PageBuilder.html#encode_port/1","title":"Phoenix.LiveDashboard.PageBuilder.encode_port/1","type":"function"},{"doc":"Encodes Sockets for URLs. Example This function can be used to encode @socket for an event value: &lt; button phx - click = &quot;show-info&quot; phx - value - info = &lt; % = encode_socket ( @socket ) % &gt; / &gt;","ref":"Phoenix.LiveDashboard.PageBuilder.html#encode_socket/1","title":"Phoenix.LiveDashboard.PageBuilder.encode_socket/1","type":"function"},{"doc":"Renders a fields card component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do fields_card ( title : &quot;Run queues&quot; , inner_title : &quot;Total&quot; , fields : [ &quot;USER&quot; : &quot;...&quot; , &quot;ROOTDIR&quot; : &quot;...&quot; ] ) end You can see it in use the Home page in the Environment section. Options These are the options supported by the component: :fields - Required. A list of key-value elements that will be shown inside the card. :title - The title above the card. Default: nil . :inner_title - The title inside the card. Default: nil . :hint - A textual hint to show close to the title. Default: nil . :inner_hint - A textual hint to show close to the inner title. Default: nil .","ref":"Phoenix.LiveDashboard.PageBuilder.html#fields_card/1","title":"Phoenix.LiveDashboard.PageBuilder.fields_card/1","type":"function"},{"doc":"Callback invoked when an event is called. Note that show_info event is handled automatically by Phoenix.LiveDashboard.PageBuilder , but the info parameter ( phx-value-info ) needs to be encoded with one of the encode_* helper functions. For more details, see Phoenix.LiveView bindings","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:handle_event/3","title":"Phoenix.LiveDashboard.PageBuilder.handle_event/3","type":"callback"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:handle_info/2","title":"Phoenix.LiveDashboard.PageBuilder.handle_info/2","type":"callback"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:handle_params/3","title":"Phoenix.LiveDashboard.PageBuilder.handle_params/3","type":"callback"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:handle_refresh/1","title":"Phoenix.LiveDashboard.PageBuilder.handle_refresh/1","type":"callback"},{"doc":"Callback invoked when a page is declared in the router. It receives the router options and it must return the tuple {:ok, session, requirements} . The page session will be serialized to the client and received on mount . The requirements is an optional keyword to detect the state of the node. The result of this detection will be passed as second argument in the menu_link/2 callback. The possible values are: :applications list of applications that are running or not. :modules list of modules that are loaded or not. :pids list of processes that alive or not.","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:init/1","title":"Phoenix.LiveDashboard.PageBuilder.init/1","type":"callback"},{"doc":"A component for drawing layered graphs. This is useful to represent pipelines like we have on BroadwayDashboard where each layer points to nodes of the layer below. It draws the layers from top to bottom. The calculation of layers and positions is done automatically based on options. Options :title - The title of the component. Default: nil . :hint - A textual hint to show close to the title. Default: nil . :layers - A graph of layers with nodes. They represent our graph structure (see example). Each layer is a list of nodes, where each node has the following fields: :id - The ID of the given node. :children - The IDs of children nodes. :data - A string or a map. If it's a map, the required fields are detail and label . :show_grid? - Enable or disable the display of a grid. This is useful for development. Default: false . :y_label_offset - The &quot;y&quot; offset of label position relative to the center of its circle. Default: 5 . :y_detail_offset - The &quot;y&quot; offset of detail position relative to the center of its circle. Default: 18 . :background - A function that calculates the background for a node based on it's data. Default: fn _node_data -&gt; &quot;gray&quot; end . :format_label - A function that formats the label. Defaults to a function that returns the label or data if data is binary. :format_detail - A function that formats the detail field. This is only going to be called if data is a map. Default: fn node_data -&gt; node_data.detail end . Examples iex&gt; layers = [ ...&gt; [ ...&gt; %{ ...&gt; id : &quot;a1&quot; , ...&gt; data : &quot;a1&quot; , ...&gt; children : [ &quot;b1&quot; ] ...&gt; } ...&gt; ] , ...&gt; [ ...&gt; %{ ...&gt; id : &quot;b1&quot; ...&gt; data : %{ ...&gt; detail : 0 , ...&gt; label : &quot;b1&quot; ...&gt; } , ...&gt; children : [ ] ...&gt; } ...&gt; ] ...&gt; ] iex&gt; layered_graph ( layers : layers , title : &quot;My Graph&quot; , hint : &quot;A simple graph&quot; )","ref":"Phoenix.LiveDashboard.PageBuilder.html#layered_graph/1","title":"Phoenix.LiveDashboard.PageBuilder.layered_graph/1","type":"function"},{"doc":"Computes a router path to the current page.","ref":"Phoenix.LiveDashboard.PageBuilder.html#live_dashboard_path/2","title":"Phoenix.LiveDashboard.PageBuilder.live_dashboard_path/2","type":"function"},{"doc":"Computes a router path to the current page with merged params.","ref":"Phoenix.LiveDashboard.PageBuilder.html#live_dashboard_path/3","title":"Phoenix.LiveDashboard.PageBuilder.live_dashboard_path/3","type":"function"},{"doc":"Callback invoked when a page is declared in the router. It receives the session returned by the init/1 callback and the capabilities of the current node. The possible return values are: {:ok, text} when the link should be enable and text to be shown. {:disabled, text} when the link should be disable and text to be shown. {:disabled, text, more_info_url} similar to the previous one but it also includes a link to provide more information to the user. :skip when the link should not be shown at all.","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:menu_link/2","title":"Phoenix.LiveDashboard.PageBuilder.menu_link/2","type":"callback"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:mount/3","title":"Phoenix.LiveDashboard.PageBuilder.mount/3","type":"callback"},{"doc":"Renders a nav bar. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do nav_bar ( items : [ phoenix_metrics : [ name : &quot;Phoenix Metrics&quot; , render : fn -&gt; table ( ... ) end ] , vm_metrics : [ name : &quot;VM Metrics&quot; , render : fn -&gt; table ( ... expensive_parameters ) end ] ] ) end You can see it in use the Metrics and Ecto info pages. Options nav_param - An atom that configures the navigation parameter. It is useful when two nav bars are present in the same page. extra_params - A list of strings representing the parameters that should stay when a tab is clicked. By default the nav ignores all params, except the current node if any.","ref":"Phoenix.LiveDashboard.PageBuilder.html#nav_bar/1","title":"Phoenix.LiveDashboard.PageBuilder.nav_bar/1","type":"function"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#c:render_page/1","title":"Phoenix.LiveDashboard.PageBuilder.render_page/1","type":"callback"},{"doc":"Renders a row component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do row ( components : [ card ( ... ) , columns ( ... ) ] ) end You can see it in use the Home page and OS Data pages. Options These are the options supported by the component: :components - Required. A list of components. It can receive up to 3 components. Each element will be one column.","ref":"Phoenix.LiveDashboard.PageBuilder.html#row/1","title":"Phoenix.LiveDashboard.PageBuilder.row/1","type":"function"},{"doc":"Renders a shared usage card component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do shared_usage_card ( usages : [ %{ data : [ { &quot;Atoms&quot; , 1.4 , &quot;green&quot; , nil } , { &quot;Binary&quot; , 9.1 , &quot;blue&quot; , nil } , { &quot;Code&quot; , 31.5 , &quot;purple&quot; , nil } , { &quot;ETS&quot; , 3.6 , &quot;yellow&quot; , nil } , { &quot;Processes&quot; , 25.8 , &quot;orange&quot; , nil } , { &quot;Other&quot; , 28.5 , &quot;dark-gray&quot; , nil } ] , dom_sub_id : &quot;total&quot; } ] , dom_id : &quot;memory&quot; , total_data : [ { &quot;Atoms&quot; , 737513 , &quot;green&quot; , nil } , { &quot;Binary&quot; , 4646392 , &quot;blue&quot; , nil } , { &quot;Code&quot; , 16060819 , &quot;purple&quot; , nil } , { &quot;ETS&quot; , 1845584 , &quot;yellow&quot; , nil } , { &quot;Processes&quot; , 13146728 , &quot;orange&quot; , nil } , { &quot;Other&quot; , 14559276 , &quot;dark-gray&quot; , nil } ] , total_legend : &quot;Total usage:&quot; total_usage : &quot;47.4 MB&quot; ) end You can see it in use the Home page and OS Data pages. Options These are the options supported by the component: :usages - Required. A list of Map with the following keys: :data - A list of tuples with 4 elements with the following data: {usage_name, usage_percent, color, hint} :dom_sub_id - Required. Usage identifier. :title - Bar title. :total_data - Required. A list of tuples with 4 elements with following data: {usage_name, usage_value, color, hint} :total_legend - Required. The legent of the total usage. :total_usage - Required. The value of the total usage. :dom_id - Required. A unique identifier for all usages in this card. :title - The title above the card. Default: nil . :inner_title - The title inside the card. Default: nil . :hint - A textual hint to show close to the title. Default: nil . :inner_hint - A textual hint to show close to the inner title. Default: nil . :total_formatter - A function that format the total_usage . Default: &amp;(&quot;\#{&amp;1} %&quot;) .","ref":"Phoenix.LiveDashboard.PageBuilder.html#shared_usage_card/1","title":"Phoenix.LiveDashboard.PageBuilder.shared_usage_card/1","type":"function"},{"doc":"Renders a table component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do table ( columns : table_columns ( ) , id : @table_id , row_attrs : &amp; row_attrs / 1 , row_fetcher : &amp; fetch_applications / 2 , title : &quot;Applications&quot; ) end You can see it in use the applications, processes, sockets pages and many others. Options These are the options supported by the component: :id - Required. Because is a stateful Phoenix.LiveComponent an unique id is needed. :columns - Required. A Keyword list with the following keys: :field - Required. An identifier for the column. :sortable - Required for at least one column. Either :asc or :desc with the default sorting. When set, the column header is clickable and it fetches again rows with the new order. Default: nil . :header - Label to show in the current column. Default value is calculated from :field . :header_attrs - A list with HTML attributes for the column header. Default: [] . :format - Function which receives the value and returns the cell information. Default is the field value itself. :cell_attrs - A list with HTML attributes for the table cell. Default: [] . :row_fetcher - Required. A function which receives the params and the node and returns a tuple with the rows and the total number: (params(), node() -&gt; {list(), integer() | binary()}) . Optionally, if the function needs to keep a state, it can be defined as a tuple where the first element is a function and the second is the initial state. In this case, the function will receive the state as third argument and must return a tuple with the rows, the total number, and the new state for the following call: {(params(), node(), term() -&gt; {list(), integer() | binary(), term()}), term()} :rows_name - A string to name the representation of the rows. Default is calculated from the current page. :default_sort_by - The default columnt to sort by to. Defaults to the first sortable column. :title - The title of the table. Default is calculated with the current page. :limit - A list of integers to limit the number of rows to show. Default: [50, 100, 500, 1000, 5000] . May be set to false to disable the limit . :search - A boolean indicating if the search functionality is enabled. Default: true . :hint - A textual hint to show close to the title. Default: nil .","ref":"Phoenix.LiveDashboard.PageBuilder.html#table/1","title":"Phoenix.LiveDashboard.PageBuilder.table/1","type":"function"},{"doc":"Renders a usage card component. It can be rendered in any dashboard page via the render_page/1 function: def render_page ( assigns ) do usage_card ( usages : [ %{ current : 10 , limit : 150 , dom_sub_id : &quot;1&quot; , title : &quot;Memory&quot; , percent : &quot;13&quot; } ] , dom_id : &quot;memory&quot; ) end You can see it in use the Home page and OS Data pages. Options These are the options supported by the component: :usages - Required. A list of Map with the following keys: :current - Required. The current value of the usage. :limit - Required. The max value of usage. :dom_sub_id - Required. An unique identifier for the usage that will be concatenated to dom_id . :percent - The used percent if the usage. Default: nil . :title - Required. The title of the usage. :hint - A textual hint to show close to the usage title. Default: nil . :dom_id - Required. A unique identifier for all usages in this card. :title - The title of the card. Default: nil . :hint - A textual hint to show close to the card title. Default: nil .","ref":"Phoenix.LiveDashboard.PageBuilder.html#usage_card/1","title":"Phoenix.LiveDashboard.PageBuilder.usage_card/1","type":"function"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#t:capabilities/0","title":"Phoenix.LiveDashboard.PageBuilder.capabilities/0","type":"type"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#t:component/0","title":"Phoenix.LiveDashboard.PageBuilder.component/0","type":"opaque"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#t:requirements/0","title":"Phoenix.LiveDashboard.PageBuilder.requirements/0","type":"type"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#t:session/0","title":"Phoenix.LiveDashboard.PageBuilder.session/0","type":"type"},{"doc":"","ref":"Phoenix.LiveDashboard.PageBuilder.html#t:unsigned_params/0","title":"Phoenix.LiveDashboard.PageBuilder.unsigned_params/0","type":"type"},{"doc":"A plug that enables request logging. See our Request Logger guides for more information.","ref":"Phoenix.LiveDashboard.RequestLogger.html","title":"Phoenix.LiveDashboard.RequestLogger","type":"module"},{"doc":"Provides LiveView routing for LiveDashboard.","ref":"Phoenix.LiveDashboard.Router.html","title":"Phoenix.LiveDashboard.Router","type":"module"},{"doc":"Defines a LiveDashboard route. It expects the path the dashboard will be mounted at and a set of options. This will also generate a named helper called live_dashboard_path/2 which you can use to link directly to the dashboard, such as: &lt; % = link &quot;Dashboard&quot; , to : live_dashboard_path ( conn , :home ) % &gt; Note you should only use link/2 to link to the dashboard (and not live_redirect/live_link , as it has to set its own session on first render. Options :live_socket_path - Configures the socket path. it must match the socket &quot;/live&quot;, Phoenix.LiveView.Socket in your endpoint. :csp_nonce_assign_key - an assign key to find the CSP nonce value used for assets. Supports either atom() or a map of type %{optional(:img) =&gt; atom(), optional(:script) =&gt; atom(), optional(:style) =&gt; atom()} :ecto_repos - the repositories to show database information. Currently only PSQL databases are supported. If you don't specify but your app is running Ecto, we will try to auto-discover the available repositories. You can disable this behavior by setting [] to this option. :env_keys - Configures environment variables to display. It is defined as a list of string keys. If not set, the environment information will not be displayed :home_app - A tuple with the app name and version to show on the home page. Defaults to {&quot;Dashboard&quot;, :phoenix_live_dashboard} :metrics - Configures the module to retrieve metrics from. It can be a module or a {module, function} . If nothing is given, the metrics functionality will be disabled. If false is passed, then the menu item won't be visible. :metrics_history - Configures a callback for retrieving metric history. It must be an &quot;MFA&quot; tuple of {Module, :function, arguments} such as metrics_history: {MyStorage, :metrics_history, []} If not set, metrics will start out empty/blank and only display data that occurs while the browser page is open. :request_logger - By default the Request Logger page is enabled. Passing false will disable this page. :request_logger_cookie_domain - Configures the domain the request_logger cookie will be written to. It can be a string or :parent atom. When a string is given, it will directly set cookie domain to the given value. When :parent is given, it will take the parent domain from current endpoint host (if host is &quot;www.acme.com&quot; the cookie will be scoped on &quot;acme.com&quot;). When not set, the cookie will be scoped to current domain. :allow_destructive_actions - When true, allow destructive actions directly from the UI. Defaults to false . The following destructive actions are available in the dashboard: &quot;Kill process&quot; - a &quot;Kill process&quot; button on the process modal Note that custom pages given to &quot;Additional pages&quot; may support their own destructive actions. :additional_pages - A keyword list of additional pages Examples defmodule MyAppWeb.Router do use Phoenix.Router import Phoenix.LiveDashboard.Router scope &quot;/&quot; , MyAppWeb do pipe_through [ :browser ] live_dashboard &quot;/dashboard&quot; , metrics : { MyAppWeb.Telemetry , :metrics } , env_keys : [ &quot;APP_USER&quot; , &quot;VERSION&quot; ] , metrics_history : { MyStorage , :metrics_history , [ ] } , request_logger_cookie_domain : &quot;.acme.com&quot; end end","ref":"Phoenix.LiveDashboard.Router.html#live_dashboard/2","title":"Phoenix.LiveDashboard.Router.live_dashboard/2","type":"macro"},{"doc":"This guide covers how to configure the LiveDashboard to show stats from your underlying database. At the moment, these stats can only be shown for Ecto repositories running on Ecto.Adapters.Postgres or Ecto.Adapters.MyXQL .","ref":"ecto_stats.html","title":"Configuring Ecto repository stats","type":"extras"},{"doc":"PostgreSQL To enable the &quot;Ecto Stats&quot; functionality for PostgreSQL in your dashboard, you will need to do the three steps below: Add the ecto_psql_extras dependency (optional) Configure the dashboard (optional) Install custom PostgreSQL extensions Add the ecto_psql_extras dependency In your mix.exs , add the following to your deps : { :ecto_psql_extras , &quot;~&gt; 0.6&quot; } , MySQL/MariaDB To enable the &quot;Ecto Stats&quot; functionality for MySQL or MariaDB in your dashboard, you will need to do the three steps below: Add the ecto_mysql_extras dependency (optional) Configure the dashboard (optional) MySQL/MariaDB configuration Add the ecto_mysql_extras dependency In your mix.exs , add the following to your deps : { :ecto_mysql_extras , &quot;~&gt; 0.3&quot; } , Configure the dashboard This step is only needed if you want to restrict the repositories listed in your dashboard, because by default all repos are gonna be listed. Go to the live_dashboard call in your router and list your repositories: live_dashboard &quot;/dashboard&quot; , ecto_repos : [ MyApp.Repo ] You want to list all repositories that connect to distinct databases. For example, if you have both MyApp.Repo and MyApp.RepoAnother but they connect to the same database, there is no benefit in listing both. Remember only Ecto repositories running on Ecto.Adapters.Postgres or Ecto.Adapters.MyXQL are currently supported. If you want to disable the &quot;Ecto Stats&quot; option altogether, set ecto_repos: [] . Some queries such as long_running_queries can be configured by passing an extra ecto_psql_extras_options for PostgreSQL or ecto_mysql_extras_options for MySQL/MariaDB, which is a keyword where: each key is the name of the query each value is itself a keyword to be passed as args For example, if you want to configure the threshold for long_running_queries : PostgreSQL example live_dashboard &quot;/dashboard&quot; , ecto_repos : [ MyApp.Repo ] , ecto_psql_extras_options : [ long_running_queries : [ threshold : &quot;200 milliseconds&quot; ] ] See the ecto_psql_extras documentation for available options. MySQL/MariaDB example live_dashboard &quot;/dashboard&quot; , ecto_repos : [ MyApp.Repo ] , ecto_mysql_extras_options : [ long_running_queries : [ threshold : 200 ] ] See the ecto_mysql_extras documentation for available options. Install custom PostgreSQL extensions Once the repository page is enabled, some of the queries (Calls and Outliers) require the pg_stat_statements extension to be installed. If you wish to access said functionality, you must install the extension first, otherwise said functionality won't be shown. MySQL/MariaDB configuration The user which is accessing the repo should have access to the certain system level databases. See the ecto_mysql_extras documentation for more details which schemas are being used. For MariaDB the performance_schema isn't enabled by default. To enable this add performance_schema=ON to my.cnf . These changes take effect after a restart. See the ecto_mysql_extras documentation for more details.","ref":"ecto_stats.html#installing-ecto-stats","title":"Configuring Ecto repository stats - Installing Ecto Stats","type":"extras"},{"doc":"This guide covers how to install and configure your LiveDashboard Metrics.","ref":"metrics.html","title":"Configuring metrics","type":"extras"},{"doc":"To enable the &quot;Metrics&quot; functionality in your dashboard, you will need to do the three steps below: Add the telemetry dependencies Define your telemetry module Configure the dashboard Add the telemetry dependencies In your mix.exs , add the following to your deps : { :telemetry_poller , &quot;~&gt; 0.4&quot; } , { :telemetry_metrics , &quot;~&gt; 0.4&quot; } , If you generated your Phoenix app in version v1.5+, these dependencies will already be installed. You can also skip the next section. Define your telemetry module In your Phoenix application, we recommend that you create a module to act as your telemetry supervision tree. Within this supervisor you can define your application's metrics and start your reporters. The example below contains the child spec for a LiveDashboard reporter, as well as some metrics definitions for telemetry events emitted by Phoenix, Ecto, and the VM (via the :telemetry_poller package). Create your Telemetry module in lib/my_app_web/telemetry.ex : defmodule MyAppWeb.Telemetry do use Supervisor import Telemetry.Metrics def start_link ( arg ) do Supervisor . start_link ( __MODULE__ , arg , name : __MODULE__ ) end @impl true def init ( _arg ) do children = [ # Telemetry poller will execute the given period measurements # every 10_000ms. Learn more here: https://hexdocs.pm/telemetry_metrics { :telemetry_poller , measurements : periodic_measurements ( ) , period : 10_000 } # Add reporters as children of your supervision tree. # {Telemetry.Metrics.ConsoleReporter, metrics: metrics()} ] Supervisor . init ( children , strategy : :one_for_one ) end def metrics do [ # Phoenix Metrics summary ( &quot;phoenix.endpoint.stop.duration&quot; , unit : { :native , :millisecond } ) , summary ( &quot;phoenix.router_dispatch.stop.duration&quot; , tags : [ :route ] , unit : { :native , :millisecond } ) , # Database Time Metrics summary ( &quot;my_app.repo.query.total_time&quot; , unit : { :native , :millisecond } ) , summary ( &quot;my_app.repo.query.decode_time&quot; , unit : { :native , :millisecond } ) , summary ( &quot;my_app.repo.query.query_time&quot; , unit : { :native , :millisecond } ) , summary ( &quot;my_app.repo.query.queue_time&quot; , unit : { :native , :millisecond } ) , summary ( &quot;my_app.repo.query.idle_time&quot; , unit : { :native , :millisecond } ) , # VM Metrics summary ( &quot;vm.memory.total&quot; , unit : { :byte , :kilobyte } ) , summary ( &quot;vm.total_run_queue_lengths.total&quot; ) , summary ( &quot;vm.total_run_queue_lengths.cpu&quot; ) , summary ( &quot;vm.total_run_queue_lengths.io&quot; ) ] end defp periodic_measurements do [ ] end end Make sure to replace MyApp and my_app by your actual application name. Then add to your main application's supervision tree (usually in lib/my_app/application.ex ): children = [ MyApp.Repo , MyAppWeb.Telemetry , MyAppWeb.Endpoint , ... ] Configure the dashboard The last step now is to configure the dashboard. Go to the live_dashboard call in your router and add the following option: live_dashboard &quot;/dashboard&quot; , metrics : MyAppWeb.Telemetry Now refresh the &quot;/dashboard&quot; page and the metrics functionality should be enabled. Each metric goes to a distinct group based on the metric name itself.","ref":"metrics.html#installing-metrics","title":"Configuring metrics - Installing metrics","type":"extras"},{"doc":"Now that you have metrics up and running, you can begin exploring the rest of the telemetry ecosystem! Here are a few links to get you started: The Telemetry.Metrics module documentation contains more information on: Metric types Breaking down metrics by tags VM Metrics Custom periodic polling For a deeper dive into Phoenix and Ecto metrics, see our Telemetry Walkthrough . For more Elixir libraries using :telemetry , see Libraries using Telemetry .","ref":"metrics.html#more-about-telemetry","title":"Configuring metrics - More about telemetry","type":"extras"},{"doc":"The LiveDashboard integrates with :telemetry converting each Telemetry.Metrics to a beautiful, real-time chart. The following table shows how Telemetry.Metrics metrics map to LiveDashboard charts: Telemetry.Metrics Y-Axis Value(s) last_value Always set to an absolute value counter Always increased by 1 sum Always increased/decreased by an absolute value summary Value/Min/Max/Avg distribution (Coming Soon) recording measurements in individual buckets Reporter options Reporter options can be given to each metric as an option. For example: counter ( &quot;my_app.counter&quot; , reporter_options : [ ... ] ) The following reporter options are available to the dashboard: :nav - configures the group the metric belongs to. By default the group is the first part of the name. For example, counter(&quot;my_app.counter&quot;) defaults to group &quot;my_app&quot; :prune_threshold - the maximum number of data points. When the threshold is reached, the chart data will be pruned by half. Default is 1_000 . Metrics history Metrics history can also be enabled via a custom configuration .","ref":"metrics.html#configure-metrics","title":"Configuring metrics - Configure Metrics","type":"extras"},{"doc":"If you wish to populate metrics with history saved from telemetry or another data source, modify the dashboard config (in &quot;my_app_web/router.ex&quot;) to include a metrics_history key like so: live_dashboard &quot;/dashboard&quot; , metrics : MyAppWeb.Telemetry , metrics_history : { MyApp.MetricsStorage , :metrics_history , [ ] } where MetricsStorage is a module and :metrics_history is a function taking a single argument in this example, which will always be a metric. The function must return a list, empty if there is no data, or a list of maps with :label , :measurement and :time keys in every map. The function Phoenix.LiveDashboard.extract_datapoint_for_metric/4 will return a map in exactly this format (with optional time argument if you want to override the default of System.system_time(:microsecond) ), or it may return nil in which case the data point should not be saved. You could store the data in an ETS table or in Redis or the database, or anywhere else, but for this example we'll use a GenServer, with a circular buffer to emit recent telemetry when each client connects. In your mix.exs , add the following to your deps : { :circular_buffer , &quot;~&gt; 0.4.0&quot; } , Then add the following module &quot;lib/my_app_web/metrics_storage.ex&quot;: defmodule MyAppWeb.MetricsStorage do use GenServer @history_buffer_size 50 def metrics_history ( metric ) do GenServer . call ( __MODULE__ , { :data , metric } ) end def start_link ( args ) do GenServer . start_link ( __MODULE__ , args , name : __MODULE__ ) end @impl true def init ( metrics ) do Process . flag ( :trap_exit , true ) metric_histories_map = metrics |&gt; Enum . map ( fn metric -&gt; attach_handler ( metric ) { metric , CircularBuffer . new ( @history_buffer_size ) } end ) |&gt; Map . new ( ) { :ok , metric_histories_map } end @impl true def terminate ( _ , metrics ) do for metric &lt;- metrics do :telemetry . detach ( { __MODULE__ , metric , self ( ) } ) end :ok end defp attach_handler ( %{ event_name : name_list } = metric ) do :telemetry . attach ( { __MODULE__ , metric , self ( ) } , name_list , &amp; __MODULE__ . handle_event / 4 , metric ) end def handle_event ( _event_name , data , metadata , metric ) do if data = Phoenix.LiveDashboard . extract_datapoint_for_metric ( metric , data , metadata ) do GenServer . cast ( __MODULE__ , { :telemetry_metric , data , metric } ) end end @impl true def handle_cast ( { :telemetry_metric , data , metric } , state ) do { :noreply , update_in ( state [ metric ] , &amp; CircularBuffer . insert ( &amp;1 , data ) ) } end @impl true def handle_call ( { :data , metric } , _from , state ) do if history = state [ metric ] do { :reply , CircularBuffer . to_list ( history ) , state } else { :reply , [ ] , state } end end end Finally, add the new module to your Application children, and initialize it with some or all of your metrics, such as from MyAppWeb.Telemetry.metrics/0 . # Start genserver to store transient metrics { MyAppWeb.MetricsStorage , MyAppWeb.Telemetry . metrics ( ) } , Now, when you select a tab on the Metrics dashboard, LiveDashboard will call into your module to get the metrics history for that tab.","ref":"metrics_history.html","title":"Configuring metrics history","type":"extras"},{"doc":"This guide covers how to install and configure your LiveDashboard OS Data.","ref":"os_mon.html","title":"Configuring OS Data","type":"extras"},{"doc":"The OS Data comes from the os_mon application, which ships as part of your Erlang distribution. You can start it by adding it to the extra applications section in your mix.exs : def application do [ ... , extra_applications : [ :logger , :runtime_tools , :os_mon ] ] end","ref":"os_mon.html#enabling-os_mon","title":"Configuring OS Data - Enabling os_mon","type":"extras"},{"doc":"See the Erlang docs for more information and os_mon configuration.","ref":"os_mon.html#configuring-os_mon","title":"Configuring OS Data - Configuring os_mon","type":"extras"},{"doc":"This guide covers how to install and configure your LiveDashboard request logger.","ref":"request_logger.html","title":"Configuring request logger","type":"extras"},{"doc":"Installing the request logger is straight-forward. Just add the following plug to your &quot;lib/my_app_web/endpoint.ex&quot;, right before Plug.RequestId : plug Phoenix.LiveDashboard.RequestLogger , param_key : &quot;request_logger&quot; , cookie_key : &quot;request_logger&quot; If your application is an API only, then you most likely don't use cookies, which means you can remove the &quot;cookie_key&quot; option. Now go to your dashboard and the Request Logger will be enabled. Once you click it, you will have the option to either pass a parameter to stream requests logs or to enable/disable a cookie that streams requests logs.","ref":"request_logger.html#installing-request-logger","title":"Configuring request logger - Installing request logger","type":"extras"},{"doc":"There is no configuration for the request logger at the moment.","ref":"request_logger.html#configuring-request-logger","title":"Configuring request logger - Configuring request logger","type":"extras"}]